#!/usr/bin/env python

# Copyright (c) 2008 Stanford University.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# - Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the
#   distribution.
# - Neither the name of the Stanford University nor the names of
#   its contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL STANFORD
# UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @author Maria Kazandjieva <mariakaz@cs.stanford.edu>
# @author Jonathan Chu <jchu3@cs.stanford.edu>
# Created: 11/05/2008

import MySQLdb
import time

#creates a unique table by using the experiment name and adding currect time and date
#table name encodes interface used

def create_table(exp_name, interface):
	# getting time and date
	temp = time.ctime(time.time())
	t = temp.split()
	t2 = t[3].split(":")
	# make unique table name
	t_name = exp_name + "_" + t[1] + "_" +  t[2] + "_" + t[4] + "_" + t2[0] + "_" + t2[1] + "_" + t2[2]
	if interface == "802.11":
		t_name += "_1"
	else:
		t_name += "_0"
	# create table
	db = MySQLdb.connect(host="localhost", user="root", passwd="", db="swat")
	cursor = db.cursor()
	cursor.execute("CREATE TABLE " + t_name + " (tx INT, rx INT, seq INT, rssi FLOAT, lqi INT, ack INT, retry INT)")
	if interface == "802.11":
		cursor.execute("CREATE TABLE " + t_name + "_ (rate INT, pktsz INT)")
	cursor.close()
	db.close()
	return t_name

# allows writing of one SWAT record to the specified database

def write_to_db(table_name, data):
	# parse data
	parsed = data.split()
	interface = table_name.rsplit("_", 1)[1];

	# open and connect to db
	db = MySQLdb.connect(host="localhost", user="root", passwd="", db="swat")
	cursor = db.cursor()
	# execute the insert query to write to database
	cursor.execute("INSERT INTO " + 
		table_name + "(tx, rx, seq, rssi, lqi, ack, retry) VALUES (" +
		parsed[0] + "," + parsed[1] + "," + parsed[2] + "," + parsed[3] + "," + parsed[4] + "," + parsed[5] + "," + parsed[6] + ")")
        if interface == "1":
		cursor.execute("INSERT INTO " + table_name + "_ (rate, pktsz) VALUES (" + parsed[7] + "," + parsed[8] + ")")
	cursor.close()
	db.close()

#adds a table to the database
def add_table(experiment_name, interface):
	dbTable = create_table(experiment_name, interface)
	
	f = open('../log/tables.txt', 'a')
	f.write(dbTable + "\n")
	f.close()
	return dbTable

def get_connection():
	return MySQLdb.connect(host="localhost", user="root", passwd="", db="swat")

def tear_down(db):
	db.close()

def write_to_db_cursor(table_name, data, cursor):
	# parse data
	parsed = data.split()
	interface = table_name.rsplit("_", 1)[1];

	# execute the insert query to write to database
	cursor.execute("INSERT INTO " + 
		table_name + "(tx, rx, seq, rssi, lqi, ack, retry) VALUES (" +
		parsed[0] + "," + parsed[1] + "," + parsed[2] + "," + parsed[3] + "," + parsed[4] + "," + parsed[5] + "," + parsed[6] + ")")
        if interface == "1":
		cursor.execute("INSERT INTO " + table_name + "_ (rate, pktsz) VALUES (" + parsed[7] + "," + parsed[8] + ")")
# example on how to use the two functions
# note: must had imported this module before hand with "import db_functions.py"
# table_name = create_table("mirage")
# write_to_db(table name, "1 2 0 10.5 3 1 2")
