#!/usr/bin/env python

import sys, time, random
import os
import tos2 as tos
import thread
import string
import threading
from pylab import *
from serial.serialutil import SerialException

#################################################################################
#										#
#				Function Blocks					#
#										#
#################################################################################

def dump(port):


    #############################################################################
    #				Dump Main					#
    #############################################################################

    #Setup serial connection and active message
    try:
	nodeTried[find(arrPorts==port)] = 1
    	s = tos.SimpleSerial(port, speed, debug=False)
	am = tos.SimpleAM(s) 			#Use the Active Message packets
    except SerialException:
    	logfile.write("Port " + str(port) + " is not working\n")
	nodeStatus[find(arrPorts==port)] = 0
	return

    sys.exit()

#################################################################################
#										#
#				Begin Program					#
#										#
#################################################################################

#Specify format for user
#print "Usage:", sys.argv[0], "57600  [<Number of motes>] [<network@255.255.255.255:10002>].......[<network@255.255.255.255:10002>] [<mote id for 1st IP address>].....[<mote id for nth IP address>] [<Source ID>] [<Destination ID>] [<IPI>] [<Number of packets>] [<Channel/Frequency>] [<Power>] [<Acks : 1 for yes no retransmit, acks-1 specifies number of retransmit attempts on failed ack (must be less than 254), 0 for no>] [<CSMA: 1 for CSMA on all packets, 2 for no CSMA, 3 for CSMA on first packet and then no CSMA>] [<Noise sampling: 1 for yes, 0 for no>] [<Noise sampling IPI (if you go really low, you will lose samples)>] [<Number of noise samples>]\n","For broadcasting, specify -1 as Destination ID\n"


#Parse Values 
speed = int(sys.argv[1])
nomotes = int(sys.argv[2])

#Index Values for ports and IDs
firstmotePort = 3
lastmotePort = 2 + nomotes
firstmoteID = lastmotePort + 1
lastmoteID = lastmotePort + nomotes

logfile = open('prog_log.txt', 'w')

#Create array of the mote ids and ports
arrPorts = array(sys.argv[firstmotePort:lastmotePort+1])

nodeTried = zeros(nomotes)
nodeStatus = ones(nomotes)

for port in arrPorts:	#Start connections to all motes in seperate threads if broadcast
    port.strip("'")
    port = str(port)
    thread.start_new_thread(dump, (port,))

while (nodeTried.sum() <nomotes):
	time.sleep(1)

if (nodeStatus.sum() == 0):
	statusfile = open('prog_status.txt', 'w')
	statusfile.write("programming: fail\n")
	statusfile.close()
else:
	print "Success"
	time.sleep(10)
	try:
		stdout = os.popen("./programNodes")
		tempstr = stdout.read()
		print "tempstr is ", tempstr
		retval = stdout.close()
		print "retval is ", retval
	except Exception, e:
		print "Something went wrong"

	statusfile = open('prog_status.txt', 'w')
	statusfile.write("programming: success\n")
	statusfile.close()
logfile.close()
