# Copyright (c) 2008 Stanford University.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# - Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the
#   distribution.
# - Neither the name of the Stanford University nor the names of
#   its contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL STANFORD
# UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @author Kannan Srinivasan <srikank@stanford.edu>
# Created: 04/11/2009

from numpy import *
from pylab import *
import sys

if (len(sys.argv) != 2):
	print "Usage: ", sys.argv[0], "<db table name>"
	sys.exit()

DBTABLENAME = sys.argv[1]

links=open('../log/' + DBTABLENAME + '/links.txt')

node = {}
nodeasrx = {}
numnodes = 0
numrxs = 0
for line in links:
	link = line.split('.')
	#print link
	tx = link[0].split('+')[0]
	rx = link[0].split('+')[1]
	if tx not in node:
		node[tx] = 0
		numnodes += 1
	if rx not in nodeasrx:
		nodeasrx[rx] = 0
		numrxs += 1
	nodeasrx[rx] += 1
	node[tx] += 1
links.close()

degree = zeros(numnodes, 'i')
indegree = zeros(numrxs, 'i')
i = 0
for nod in node:
	degree[i] = node[nod]
	i += 1

i = 0
for nod in nodeasrx:
	indegree[i] = nodeasrx[nod]
	i += 1

tabfile = open('../log/'+DBTABLENAME+'/tablefile', 'a')
tabfile.write("degree: " + str(round(degree.mean(),2)) + " " + str(round(indegree.mean(),2)) + "\n")
tabfile.close()
