import MySQLdb
import sys
from pylab import array, ones

if (len(sys.argv)!=4):
	print "Usage: ", sys.argv[0], " <database name> <tx> <num of packets>"
	sys.exit(0)

db_name = sys.argv[1]
tx = int(sys.argv[2])
PACKETS = int(sys.argv[3])

links = open('../log/%s/links.txt' % db_name,'r')
filename = 'xcorrfile-'+str(tx)+'.txt'
xcorrfile = open(filename,'w')

nodes = []

for line in links:
	x = line[:-1].split('+')
	if (tx==int(x[0])):
		nodes.append(int(x[1].split('.')[0]))

rcvr = array(nodes)

db = MySQLdb.connect(host="localhost", user="root", passwd="", db="swat")
cursor1 = db.cursor()
cursor2 = db.cursor()

for i in range(0,len(rcvr)):
	for j in range(i+1,len(rcvr)):
		r1 = -1*ones(PACKETS, 'i')
		r2 = -1*ones(PACKETS, 'i')
		rx1 = rcvr[i]
		rx2 = rcvr[j]
		cursor1.execute("SELECT * FROM %s WHERE rx = %d AND tx = %d AND ack = 0 AND lqi < 255" % (db_name, rx1, tx))
		cursor2.execute("SELECT * FROM %s WHERE rx = %d AND tx = %d AND ack = 0 AND lqi < 255" % (db_name, rx2, tx))
		for k in range(int(cursor1.rowcount)):
			row = cursor1.fetchone()
			seq = int(row[2])
			if (seq <= PACKETS):
				r1[seq-1] = 1
		for k in range(int(cursor2.rowcount)):
			row = cursor2.fetchone()
			seq = int(row[2])
			if (seq <= PACKETS):
				r2[seq-1] = 1

		#Calculating the index
		EXY = 0.0
		for k in range(0,PACKETS):
			EXY += r1[k]*r2[k]/float(PACKETS)
		mu_x = r1.sum()/float(PACKETS)
		mu_y = r2.sum()/float(PACKETS)
		sig_x = r1.std()
		sig_y = r2.std()
		if (sig_x != 0 and sig_y != 0):
			temp = float(EXY - (mu_x*mu_y))/float(sig_x*sig_y)
			prr_x = (mu_x + 1.0)/2.0
			prr_y = (mu_y + 1.0)/2.0
	
			xcorrfile.write(str(rx1) + " " + str(rx2) + " " + str(prr_x) + " " + str(prr_y) + " " + str(temp) + "\n")

cursor1.close()
cursor2.close()
db.close()
xcorrfile.close()
links.close()
