# Copyright (c) 2008 Stanford University.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# - Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the
#   distribution.
# - Neither the name of the Stanford University nor the names of
#   its contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL STANFORD
# UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @author Kannan Srinivasan <srikank@stanford.edu>
# @author Saatvik agarwal <logolas@stanford.edu>
# @author Maria Kazandjieva <mariakaz@stanford.edu>
# @author Edward Kim <edskim@stanford.edu>
# @author Mayank Jain <mayjain@stanford.edu>
# Created: 11/05/2008

import math
import os
import commands
from numpy import *
import MySQLdb

sql = MySQLdb

def calculateall (dbTable,PACKETS, IPI) :
	links=open('../log/' + dbTable + '/links.txt')
	kwdistArr= [] #open('../metricdata/kwdist'+str(IPI)+'inter.txt','w')
	k=100 #to be modified in actual program  

	db = sql.connect(host="localhost", user="root", passwd="", db="swat")
	packcursor = db.cursor()

	for line1 in links:
	    link = line1.split('.')

	    tx = link[0].split('+')[0]
	    rx = link[0].split('+')[1]	    

	    packcursor.execute("SELECT * FROM " + dbTable + " WHERE tx = " + str(tx) + " AND rx = " + str(rx) + " AND ack = 0 AND lqi < 255" )
	    packetsreceived = int(packcursor.rowcount)

	    #f=open("../../linksdata/pkt/" + line1[:-1],'r')
	    recd = [] # keep track of the packets that have been received, according to the data text files
	    yesr = [] # how many times, after a success of n, did we have a success of i elements (i<n), i is the array index
	    nor = [] # how many times, after a success of n, did we have a failure of i elements
	    probr1 = []
	    probr2 = []
	    yesnr = [] # how many times, after a failure of n, did we have a success of i elements, i is the array index
	    nonr = [] #  how many times, after a failure of n, did we have a failure of i elements
	    #probnr = []
	    pos1 = []
	    pos2 = []
	    ideal = []
	    #neg = []

	    # initialize received array to all FALSE
	    for i in range (0, PACKETS+1):
	        recd.append(False)

	    # initialize all statistic-keeping arrays
	    for i in range (0,k+1):
	        yesr.append(0)
	        nor.append(0)
	        yesnr.append(0)
	        nonr.append(0)
		
	    norecd = 0 # number of received packets based on the data
	    for i in range(0, packetsreceived):
	        x = packcursor.fetchone()
	    #for line in f:   #For each packet for this link, check seq numbers < packets and mark received
	        norecd += 1	# increase for each line in the data file
	        if (int(x[2])<=PACKETS):
	            if recd[int(x[2])] != True:
	                recd[int(x[2])]=True # mark the packets that have been receieved
	            else:
                        norecd-=1

	    prr = float(norecd)/float(PACKETS) # packet received ratio
	    if (prr < 0.1 or prr > 0.9): # ignore 0% and 100% links?
	        continue

	    num00 = 0
	    num010 = 0
	    num000 = 0

	    for i in range (1, PACKETS):
		    if (i>1):
			    if (bool(recd[i])==False and bool(recd[i-1])==False):
				    num00+=1
		    if (i>2):
			    if (bool(recd[i])==False and bool(recd[i-1])==False and bool(recd[i-2])==False):
				    num000+=1
			    elif (bool(recd[i])==False and bool(recd[i-1])==True and bool(recd[i-2])==False):
				    num010+=1
				    

	    cur = bool(recd[0]) # cur - has the currect packet been received or was it dropped
	    l, r = 0, 0 #r-received packet; l-last received
	    while (1):
	        if (r<PACKETS and recd[r+1]==cur): #if haven't reached the end of packets and packet is received. r++
	                r+=1
	        else : #packet was not received
	            diff = r-l+1 # diff is the number of successfully received packets in a row
	            if (r == PACKETS):
	                if (cur == True):
	                    for i in range (1,min(diff,k)+1):
	                        yesr[i]+=diff-i
	                else:
	                    for i in range (1,min(diff,k)+1):
	                        nonr[i]+=diff-i
	                break
	            else:
	                
	                if (cur == True):
	                    for i in range (1,min(diff,k)+1):
	                        nor[i]+=1
	                        yesr[i]+=diff-i
	                else :
	                    for i in range (1,min(diff,k)+1):
	                        yesnr[i]+=1
	                        nonr[i]+=diff-i
	            r+=1
	            l = r
	            cur = recd[r]

	    # calculate probabilities for each paket
	    for i in range (1,k+1):
	        if (nor[i]+yesr[i]!=0 and nor[i]+yesr[i]>=100):
	            probr1.append(float(yesr[i])/float(nor[i]+yesr[i]))
	            pos1.append(i)
	        if (nonr[i]+yesnr[i]!=0 and nonr[i]+yesnr[i]>=100):
	            probr2.append(float(yesnr[i])/float(nonr[i]+yesnr[i]))
	            pos2.append(-1*i)

	    goodfile=line1[:-1]+"good.txt"
	    cpdffile=line1[:-1]+"cpdf.txt"
	    indyfile=line1[:-1]+"indy.txt"

	    #if (len(pos1) == 0 or len(pos2) == 0):
	        #continue
		    
	    good=open(goodfile,'w')
	    cpdf=open(cpdffile,'w')
	    indy=open(indyfile,'w')

	    for i in range (0,len(pos1)):
	            good.write(str(pos1[i]) + " 1\n")
	            cpdf.write(str(pos1[i]) + " " + str(probr1[i]) + "\n")
	            indy.write(str(pos1[i]) + " " + str(prr) + "\n")
	    for i in range (0,len(pos2)):
	            good.write(str(pos2[i]) + " 0\n")
	            cpdf.write(str(pos2[i]) + " " + str(probr2[i]) + "\n")
	            indy.write(str(pos2[i]) + " " + str(prr) + "\n")
	    
	    good.close()
	    cpdf.close()
	    indy.close()


	    tempcommand = "./eval " + cpdffile + " " + goodfile
	    stdout = os.popen(tempcommand)
	    tempstr = stdout.read()
	    retval = stdout.close()
	    #print tempcommand
	    
	    #tempstr = os.system(tempcommand)
	    tempcommand2 = "./eval " + goodfile + " " + indyfile
	    stdout = os.popen(tempcommand2)
	    tempstr2 = stdout.read()
	    retval = stdout.close()	    
	    #tempstr2 = os.system(tempcommand2)
	    #print tempstr
	    #print tempcommand2
	    #kwdist = 0.1
	    #kwdist2 = 0.2

	    kwdist = float(tempstr[4:])
	    kwdist2 = float(tempstr2[4:])
	    os.remove(goodfile)
	    os.remove(cpdffile)
	    os.remove(indyfile)

	    kwdistArr.append(str(kwdist)+ " " + str(kwdist2) + " " + str(line1[:-1]) + "\n")

	#close stuff
	#kwdist.close()
	packcursor.close()
	db.close()
	return kwdistArr

