from numpy import *
from pylab import *
import sys
import noisecalc
import os

clf()

gridWidth = 0.1
textSize = 28
curveWidth = 4
scatterbubblesize = 100
xaxispadding = 15
figwidth = 10
figheight = 7
gridcolor = '0.5'
gridtransparency = 0.5
font = 'sans-serif'

if (len(sys.argv) != 2):
	print "Usage: ", sys.argv[0], " <table name>"
	sys.exit()

DBTABLENAME = sys.argv[1]

#color = ['#CC3366', '#CC3399',  '#990099',  '#0033FF', '#00CCFF']
color = 'blue'

def plotnoisedistr(col, DBTABLENAME):
	noise_floor = noisecalc.calculateall(DBTABLENAME)
	
	frequency = {}
	unique_noise = []
	for x in noise_floor:
		if (x in frequency):
			frequency[x] += 1.00
		else:
			unique_noise.append(float(x)-0.5)
			frequency[x] = 1.00
	#print frequency.values()/(array(frequency.values()).sum())
	
	fig = figure(1)
	fig.set_size_inches(figwidth, figheight)
	ax = fig.add_subplot(111)
	ax.xaxis.set_ticks_position('bottom')
	ax.yaxis.set_ticks_position('left')
	
	for tick in ax.xaxis.get_major_ticks():
		tick.set_pad(xaxispadding)
	for tick in ax.yaxis.get_major_ticks():
		tick.set_pad(xaxispadding)
	             
	
	subplots_adjust(left=0.14, right=0.9, bottom=0.23, top=0.96)
	grid(True,linewidth=gridWidth,color=gridcolor,alpha=gridtransparency)
	
	xticklabels = get(gca(), 'xticklabels')
	setp(xticklabels, weight='bold', fontsize=textSize, fontname=font)

	yticklabels = get(gca(), 'yticklabels')
	setp(yticklabels, weight='bold', fontsize=textSize, fontname=font)
	
	#print unique_noise
	bar(unique_noise, frequency.values()/(array(frequency.values()).sum()), width=1.0, bottom=-0.01)	
	ylabel("Probability", family=font, weight='bold', fontsize=32)
	xlabel("Noise Floor", family=font, weight='bold', fontsize=32)
	
	axis([array(unique_noise).min()-0.1, array(unique_noise).max()+1.1, -0.01, 1.01] )

	savefig("../../plots/noise-distr.pdf", dpi=50)
	savefig("../../plots/noise-distr.png", dpi=35)
	

plotnoisedistr(color, IPI)
