from numpy import *
from pylab import *
import os

def plotfcn(xcorr, dbTable):
	clf()
	
	gridWidth = 0.1
	textSize = 28
	curveWidth = 4
	scatterbubblesize = 100
	xaxispadding = 15
	figwidth = 10
	figheight = 7
	gridcolor = '0.5'
	gridtransparency = 0.5
	font = 'sans-serif'

	fig = figure(1)
	fig.set_size_inches(figwidth, figheight)
	ax = fig.add_subplot(111)
	ax.xaxis.set_ticks_position('bottom')
	ax.yaxis.set_ticks_position('left')
	
	for tick in ax.xaxis.get_major_ticks():
		tick.set_pad(xaxispadding)
	for tick in ax.yaxis.get_major_ticks():
		tick.set_pad(xaxispadding)
	             
	
	subplots_adjust(left=0.2, right=0.9, bottom=0.23, top=0.96)
	grid(True,linewidth=gridWidth,color=gridcolor,alpha=gridtransparency)
	
	xticklabels = get(gca(), 'xticklabels')
	setp(xticklabels, weight='bold', fontsize=textSize, fontname=font)
	
	yticklabels = get(gca(), 'yticklabels')
	setp(yticklabels, weight='bold', fontsize=textSize, fontname=font)
	
	xcov = array(xcorr)
	xcov.sort()
	
	arr = xcov
	# setup figure
	fig = figure(1)
	fig.set_size_inches(figwidth, figheight)

	if len(arr) == 0:
		axis([-1, 1, 0, 100])
		axis('off')
		text(0, 50, "No valid data points", ha = 'center', va = 'center', weight = 'bold', fontsize = 30)
	else:
		value = []
		occurances = []
		percentage = []
		
		value.append(arr[0])
		occurances.append(1)
		j = 0
		
		for i in range(1,len(arr)):
			if (arr[i] > value[j]):
				j += 1
				value.append(arr[i])
				occurances.append(1)
			else:
				occurances[j] +=1
		total = 0
		for k in range(0, len(value)):
			total += occurances[k]
			percentage.append(100 - 100*(float(total)/float(len(arr))))
	
		ax = fig.add_subplot(111)
		ax.xaxis.set_ticks_position('bottom')
		ax.yaxis.set_ticks_position('left')
	
		for tick in ax.xaxis.get_major_ticks():
			tick.set_pad(xaxispadding)
		for tick in ax.yaxis.get_major_ticks():
			tick.set_pad(xaxispadding)
			
		subplots_adjust(left=0.2, right=0.9, bottom=0.23, top=0.96)
		grid(True,linewidth=gridWidth,color=gridcolor,alpha=gridtransparency)
		
		xticklabels = get(gca(), 'xticklabels')
		setp(xticklabels, weight='bold', fontsize=textSize, fontname=font)
		
		yticklabels = get(gca(), 'yticklabels')
		setp(yticklabels, weight='bold', fontsize=textSize, fontname=font)

		#print value, percentage
		value_plot = concatenate(([-1],value,[1]),0)
		percentage_plot = concatenate(([100.0], percentage,[0.0]),0)
		for i in range(0, len(value_plot)-1):
			plot([value_plot[i], value_plot[i+1]], [percentage_plot[i], percentage_plot[i]], 'b-', linewidth=4)
			plot([value_plot[i+1], value_plot[i+1]], [percentage_plot[i], percentage_plot[i+1]], 'b-', linewidth=4)
	
		axis([-1, 1, 0, 100])
		ylabel("% of link pairs", family=font, weight='bold', fontsize=32)
	
		xlabel(r"$\rho$", family=font, weight='bold', fontsize=52)
	
	savefig("../reports/%s/plots/spatial-rho.png" % dbTable, dpi=50)
	#savefig("../plots/xcorr-alltx.pdf", dpi=50)


#if (len(sys.argv)!=3):
#	print "Usage: ", sys.argv[0], " <num_tx> <tx1> <tx2> ... <txnum_tx> <num of packets>"
#	sys.exit(0)

db_table = sys.argv[1]
numtx = int(sys.argv[2])
PACKETS = int(sys.argv[3])
tx_arr = []
xcorr = []
meanetx = []
perc5etx = []
perc10etx = []
perc90etx = []
perc95etx = []
etx_diff_abc_ac = []
meanetxinderatio = []
xcorr_subset = []
meanetx_subset = []
meanetxinderatio_subset = []

for i in range(4,4+numtx):
	tx_arr.append(int(sys.argv[i]))

print tx_arr
xcorr = []
for tx in tx_arr:
	print "Collecting Data for Node ", str(tx)
	filename = 'xcorrfile-'+str(tx)+'.txt'
	xcorrfile = open(filename, 'r')
	for line1 in xcorrfile:
		x = line1.split()
		xcorr.append(float(x[4]))
	xcorrfile.close()
	#cleanup files created by compute_xcorrindex.py
	try:
		os.remove(filename)
	except OSError:
		pass
	
plotfcn(xcorr, db_table)
