from numpy import *
from pylab import *
import sys

gridWidth = 0.1
textSize = 28
curveWidth = 4
scatterbubblesize = 100
xaxispadding = 15
figwidth = 10
figheight = 7
gridcolor = '0.5'
gridtransparency = 0.5
font = 'sans-serif'

#color = ['#CC3366', '#CC3399',  '#990099',  '#0033FF', '#00CCFF']

def plotprrvsrssi(DBTABLENAME, prr, avgrssi, stdrssi, avgcci, stdcci):
	clf()
	#prrfile = open('../metricdata/prrfile'+str(IPI)+'all.txt')
	#prr = []
	#avgrssi = []
	#stdrssi = []
	
	#for line1 in prrfile:
	#    x = line1.split()
	#    prr.append(float(x[0])) # packet reception ratio
	#    avgrssi.append(float(x[1]))
	#    stdrssi.append(float(x[2]))
	#prrfile.close()

	fig = figure(1)
	fig.set_size_inches(figwidth, figheight)
	ax = fig.add_subplot(111)
	ax.xaxis.set_ticks_position('bottom')
	ax.yaxis.set_ticks_position('left')
	
	for tick in ax.xaxis.get_major_ticks():
		tick.set_pad(xaxispadding)
	for tick in ax.yaxis.get_major_ticks():
		tick.set_pad(xaxispadding)
	             
	
	subplots_adjust(left=0.14, right=0.9, bottom=0.23, top=0.96)
	grid(True,linewidth=gridWidth,color=gridcolor,alpha=gridtransparency)
	
	xticklabels = get(gca(), 'xticklabels')
	setp(xticklabels, weight='bold', fontsize=textSize, fontname=font)

	yticklabels = get(gca(), 'yticklabels')
	setp(yticklabels, weight='bold', fontsize=textSize, fontname=font)

	plot(avgrssi, prr, 'o', markersize=6)
	hold('on')
	plot(array(avgrssi)+array(stdrssi), prr, '|', linewidth=2, color="gray")
	plot(array(avgrssi)-array(stdrssi), prr, '|', linewidth=2, color="gray")
	for i in range(0,len(prr)):
		plot([avgrssi[i]+stdrssi[i], avgrssi[i]-stdrssi[i]], [prr[i], prr[i]], '-', linewidth=2, color="gray")

	ylabel("Reception Ratio", family=font, weight='bold', fontsize=32)
	
	if DBTABLENAME.rsplit("_", 1)[1] == "1": # is 802.11?
		xlabel("SNR (dB)", family=font, weight='bold', fontsize=32)
		#axis([-0.01, 40.01, -0.01, 1.01])
		xlim(xmin=0)
		ylim(ymin=0)
		img = "../reports/" + DBTABLENAME + "/plots/prr-snr.png"
	else:
		xlabel("RSSI (dBm)", family=font, weight='bold', fontsize=32)
		axis([-110.01, -30.01, -0.01, 1.01])
		img = "../reports/" + DBTABLENAME + "/plots/prr-rssi.png"
	
	#leg = legend(loc='lower left')
	#texts = leg.get_texts()
	#for te in texts:
	   #te.set_family(font)
	   #te.set_fontsize(24)

	#savefig("../reports/" + DBTABLENAME + "/plots/prr-rssi.pdf", dpi=50)
	savefig(img, dpi=50)


#plotprrvsrssi(DBTABLENAME, PACKETS, RAWIPI, IPIs, color)
