# Copyright (c) 2008 Stanford University.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# - Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the
#   distribution.
# - Neither the name of the Stanford University nor the names of
#   its contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL STANFORD
# UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @author Kannan Srinivasan <srikank@stanford.edu>
# Created: 11/05/2008

from numpy import *
from pylab import *
import MySQLdb

sql = MySQLdb

def calculatealldict (dbTable):
	noisefloor = {}
	nodes = []
	snr = {}

	links=open('../log/' + dbTable  + '/links.txt')
	#prrfile = open('../metricdata/prrfile'+str(IPI)+'all.txt','w')
	db = sql.connect(host="localhost", user="root", passwd="", db="swat")

	for line1 in links:
	    link = line1.split('.')
	    #print link
	    tx = int(link[0].split('+')[0])
	    rx = int(link[0].split('+')[1])
	    if (len(find(array(nodes)==tx))==0):
	    	nodes.append(tx)
	    if (len(find(array(nodes)==rx))==0):
	    	nodes.append(rx)
	    cursor = db.cursor()
	    cursor.execute("SELECT * FROM " + dbTable + " WHERE tx = " + str(tx) + " AND rx = " + str(rx) + " AND ack = 0 AND lqi < 255")
	    numrows = int(cursor.rowcount)
	    rssi = []
	    for i in range(0, numrows):
	        x = cursor.fetchone()
		rssi.append(x[3])
	    linkForward = str(tx) + " " + str(rx)

       	    cursor.execute("SELECT * FROM " + dbTable + " WHERE rx = " + str(rx) + " AND lqi = " + str(255))
            numrows = int(cursor.rowcount)
            noise = []
            for i in range(0, numrows):
                x = cursor.fetchone()
                noise.append(x[3])
	    cursor.close()

            val = array(noise)
            frequency = {}
            for x in val:
            	if (x in frequency):
            		frequency[x] += 1
            	else:
           		frequency[x] = 1
            #print frequency
            mode = max(frequency.values())
            for x in frequency: 
            	if (mode == frequency[x]):
            		noisefloor[rx] = x

	    snr[linkForward] = array(rssi).mean() - noisefloor[rx]

	db.close()
	links.close()
	return snr
