# script that parses the log file retreived from the 802.11 nodes and puts the data into the database
# @author Jonathan Chu <jchu3@cs.stanford.edu>

import sys, os
sys.path.append(os.getcwd().rsplit("/", 2)[0] + "/experimentfiles")
from db_functions import write_to_db
#usage: python parse_files.py dbTable node_file transmitter
#@param dbTable the database table that should contain the data
#@param node_file the file containing the nodes
#@param transmitter the position in the node_file of the node that is transmitting
dbTable = sys.argv[1]
nodeFile = sys.argv[2]
transmitter = sys.argv[3]

#map node hex ip addresses to ids
node_open = open(nodeFile, "r")
#mapping that maps ip address in hex to node id specified in the node file
node_hash = {}
#mapping that maps the position of the node in the node file to the node id specified in that file
#this is because swan-client requires the nodes have ids based on their position in the file,
#but the link file sets the nodes to have ids based on what is in the nodes file
node_index_to_id = {}
i = 0
for line in node_open:
    parts = line.split()
    node_hash[int(parts[3], 16)] = parts[0]
    node_index_to_id[i] = parts[0]
    i += 1
node_open.close()

#function that actually puts the data into the database
def read_file(filename):
    if os.path.getsize(filename) == 0:
        return False
    file = open(filename, "r")
    for line in file:
        parts = line.split()
        transmit_id = node_hash[int(parts[0], 16)]
        receive_id = node_hash[int(parts[1], 16)]
        write_to_db(dbTable, transmit_id + " " + receive_id + " " +
                    parts[2] + " " + parts[3] + " 0 0 0 " + parts[6] + " " + parts[8])
    file.close()
    return True
        
path = "swat_log_"
link_open = open("../../log/" + dbTable + "/links.txt", "a")

for node in range(0, i):
    if node != int(transmitter):
        file = path + transmitter + str(node)
        #want to continue reading possible files
        try:
            if read_file(file):
                #update the link file
                link_open.write(node_index_to_id[int(transmitter)] + "+" + node_index_to_id[node] + "\n")
        except IOError:
            pass
        except OSError:
            pass
        #remove the file
        try:
            os.remove(file)
        except OSError:
            pass
link_open.close()
