#!/usr/bin/env python

# Copyright (c) 2008 Stanford University.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# - Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# - Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the
#   distribution.
# - Neither the name of the Stanford University nor the names of
#   its contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL STANFORD
# UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @author Maria Kazandjieva <mariakaz@cs.stanford.edu>
# @date: 11/12/2008
#
# Code to upload SWAT databases to the sing server


import MySQLdb
import os
import shutil
import subprocess
from socket import *

host = 'sing.stanford.edu'
success = -1

def tar_and_upload(table_name, expname):
	# create table_name dir
	dirname = table_name
	if not os.path.isdir("./" + dirname + "/"):
		os.mkdir("./" + dirname + "/")	
	# create file to dump database in
	f = open(dirname + "/" + table_name, 'w')

	# copy expname.config into that dir
	shutil.copyfile("../config/" + expname + ".config", dirname + "/" +
expname + ".config") 	

	# dump mysql database into a file in the new dir
	db = MySQLdb.connect(host="localhost", user="root", passwd="",
db="swat")
	cursor = db.cursor()
	cursor.execute("SELECT * from " + table_name)
	while 1:
		entry = cursor.fetchone()
		if entry == None:
			break
		else:
			i = 0
			for i in range (0, len(entry)):
				if i != 0:
					f.write(", ")
				f.write(str(entry[i]))
			f.write("\n")		 

	# bzp2 newdr
	args = "-cjf"
	zipname = dirname + ".tar.bz"
	args3 = dirname + "/"
	output = subprocess.call(["tar", args, zipname, args3])
	
	# send as binary
	s = socket(AF_INET, SOCK_STREAM)
	s.settimeout(10)
	try:
		s.connect((host, 12358))
	except:
		shutil.rmtree(dirname + "/")
		os.remove(zipname)
		return -1

	# simple handshake to give filename
	try:
		s.send("name " + zipname)
		f = open(zipname, 'rb')
		while 1:
			buf = f.read(1024)
			if buf:
				s.send(buf)
			else:
				break
	except:
		shutil.rmtree(dirname + "/")
		os.remove(zipname)
		return -1
	# delete bziped dir
	shutil.rmtree(dirname + "/")
	os.remove(zipname)
	success = 0
	return success
